#include <iostream>

using namespace std;
int najveca(int a[],int n,int pozl)
{
    int poz=n-1;
    int najv=a[n-1];
    for(int i=n-2;i>pozl;i--)
    {
        if(a[i]>najv)
        {
            najv=a[i];
            poz=i;
        }
    }
    return poz;
}

void funkcija(int a[],int n,int pozl)
{
      int poz=najveca(a,n,pozl);
      int kvrc=0;
      for(int i=pozl;i<poz;i++){
          if(a[i]<a[poz]){
              int pom=a[i];
              a[i]=a[poz];
              a[poz]=pom;
              kvrc=1;
              break;
          }
      }
      if(kvrc==1){
        for(int i=0;i<n;i++){
           cout<<a[i]<<" ";
        }
      }
      else{
          poz++;
          if(poz==n-2||poz==n-1){
              if(a[n-2]>a[n-1])
                for(int i=0;i<n;i++){
                    cout<<a[i]<<" ";
                }
              else{
                  for(int i=0;i<n-2;i++){
                      cout<<a[i]<<" ";
                  }
                  cout<<a[n-1]<<" "<<a[n-2];
              }
          }
          else
            funkcija(a,n,poz);
      }
}

int main()
{
    int n;
    cin>>n;
    int a[n];
    int d=0;
    for(int i=0;i<n;i++)
        cin>>a[i];
    if(n==2)
    {
        cout<<a[1]<<" "<<a[0];
    }
    else{
     for(int i=1;i<n;i++){
            if(a[i]>=a[i-1]){
                d=1;
                break;
            }
      }

      if(d==0)
      {
         for(int i=0;i<(n-2);i++){
                cout<<a[i]<<" ";
         }
         cout<<a[n-1]<<" "<<a[n-2];
      }
      else{
            funkcija(a,n,0);
      }
    }
    return 0;
}